<?php

require "CallerService.php";

// Static Variables
$api_get_cid_method = "GET_CAMPAIGNS";
$api_get_template_method = "GET_TEMPLATES";
$api_send_alert_method = "ALERT_MESSAGE";
$api_version = "5.00";
$alert_active = "Y";

// Member Variables
$api_username = $_POST["api_username"];
$api_password = $_POST["api_password"];
$api_signature = $_POST["api_signature"];
$cid = $_POST["cid"];
$alert_template = $_POST["alert_template"];
$alert_title = $_POST["alert_title"];
$alert_link = $_POST["alert_link"];
$alert_expiry = $_POST["alert_expiry"];
$alert_message = $_POST["alert_message"];
$doaction = $_POST["doaction"];

// Send alert
if ($api_username != "" AND $api_password != "" AND $api_signature != "" AND $alert_expiry != "" AND $doaction == "send_alert")
{
  
	// Make Data Request
	$reqParams = "&VERSION=".urlencode($api_version)."&PASS=".urlencode($api_password)."&USER=".urlencode($api_username)."&SIGN=".urlencode($api_signature)."&cid=".urlencode($cid)."&alert_title=".urlencode($alert_title)."&alert_message=".urlencode($alert_message)."&alert_link=".urlencode($alert_link)."&alert_expiry=".urlencode($alert_expiry)."&alert_template=".urlencode($alert_template)."&alert_active=".urlencode($alert_active);

	// Call the API
	$resArray=api_call("$api_send_alert_method",$reqParams);

	// Get the Result and Response
	$result = strtoupper($resArray["RESULT"]);
	$response = strtoupper($resArray["RESPONSE"]);

	// If Failed Result, Email Admin about Failure Call
	if($result != "SUCCESS")  
	{
		$api_details = "";
		foreach ($resArray as $key=>$value)
		{
			$api_details.="$key=$value\n";
		}
		$msg = "API Call Failed: $api_details<br />";
	}
	else
		$msg = "Alert Sent Successfully.<br />";
}

// Show Alert Form
if ($api_username != "" AND $api_password != "" AND $api_signature != "" AND $cid != "" AND $alert_template != "" AND $doaction != "logoff")
{
?>
<html><head><title>BusinessAlerts API Simple Alert Post</title></head>
<body>
<h1>BusinessAlerts API Simple Alert Post</h1>
<form method="post" action="<?php echo $_SERVER["PHP_SELF"] ?>" id="simple_post" name="simple_post">
<input type=hidden name="api_username" value="<?php echo $api_username?>">
<input type=hidden name="api_password" value="<?php echo $api_password?>">
<input type=hidden name="api_signature" value="<?php echo $api_signature?>">
<input type=hidden name="cid" value="<?php echo $cid?>">
<input type=hidden name="alert_link" value="<?php echo $alert_link?>">
<input type=hidden name="alert_expiry" value="<?php echo $alert_expiry?>">
<input type=hidden name="alert_template" value="<?php echo $alert_template?>">
<input type=hidden name="doaction" id="doaction">
<h2>Post Your Alert Message</h2>
<strong><?php echo $msg?></strong><br />
Alert Title: <input type=text name="alert_title" size="50" value="<?php echo $alert_title?>"><br />
Alert Message:<br /> <textarea name="alert_message" rows="10" cols="50"></textarea><br />
<input type=button name=button value="Post Alert Message" onclick="document.getElementById('simple_post').doaction.value='send_alert';document.getElementById('simple_post').submit();return false;">
<input type=button name=button value="Log Off" onclick="document.getElementById('simple_post').doaction.value='logoff';document.getElementById('simple_post').submit();return false;">
</form>
</body>
</html>
<?php
  exit;
}

// check credentials and get templates and campaigns
if ($api_username != "" AND $api_password != "" AND $api_signature != "")
{
	// Make Data Request
	$reqParams = "&VERSION=".urlencode($api_version)."&PASS=".urlencode($api_password)."&USER=".urlencode($api_username)."&SIGN=".urlencode($api_signature);

	// Call the API
	$resArray=api_call("$api_get_cid_method",$reqParams);

	// Get the Result and Response
	$result = strtoupper($resArray["RESULT"]);
	$response = strtoupper($resArray["RESPONSE"]);

	//echo "Response: $response<br />";
	// If Failed Result, Email Admin about Failure Call
	if($result != "SUCCESS")  
	{
		$api_details = "";
		foreach ($resArray as $key=>$value)
		{
			$api_details.="$key=$value\n";
		}
		$msg = "API Call Failed: $api_details<br />";
	}
	else
	{
		$msg = "API Call Successful.";
		
		$cid_dropdown = "";
		$response_array = explode(",",$response);
		foreach ($response_array as $pair)
		{
			list($id,$name) = explode(":",$pair);
			if ($id != "" AND $name != "")
				$cid_dropdown.= "<option value='$id'>$name</option>";
		}
		
		// Make Data Request
		$reqParams = "&VERSION=".urlencode($api_version)."&PASS=".urlencode($api_password)."&USER=".urlencode($api_username)."&SIGN=".urlencode($api_signature);

		// Call the API
		$resArray=api_call("$api_get_template_method",$reqParams);

		// Get the Result and Response
		$result = strtoupper($resArray["RESULT"]);
		$response = strtoupper($resArray["RESPONSE"]);
		//echo "Response: $response<br />";
		if($result == "SUCCESS")  
		{
			$template_dropdown = "";
			$response_array = explode(",",$response);
			foreach ($response_array as $pair)
			{
				list($id,$name) = explode(":",$pair);
				if ($id != "" AND $name != "")
					$template_dropdown.= "<option value='$id'>$name</option>";
			}
		}
?>
<html><head><title>BusinessAlerts API Simple Alert Post</title></head>
<body>
<h1>BusinessAlerts API Simple Alert Post</h1>
<h2>Please fix some global settings</h2>
<form method="post" action="<?php echo $_SERVER["PHP_SELF"] ?>" id="simple_post" name="simple_post">
<input type=hidden name="api_username" value="<?php echo $api_username?>">
<input type=hidden name="api_password" value="<?php echo $api_password?>">
<input type=hidden name="api_signature" value="<?php echo $api_signature?>">
Choose Alert Group: <select name='cid' id='cid'><?php echo $cid_dropdown ?></select><br />
Choose Alert Template: <select name='alert_template' id='alert_template'><?php echo $template_dropdown ?></select><br />
Alert Link: <input type=text name="alert_link" size="30">[Optional][Use if Template uses this]<br />
Alert Expiry: <input type=text name="alert_expiry" size="30">[e.g. 10 SECOND, 15 MINUTE, 1 HOUR, 5 DAY etc, ]<br />
<input type=submit name=submit value="Proceed to Alert Message">
</form>
</body>
</html>
<?	
exit;
	}
}
// Show Authentication and Settings Form
?>
<html><head><title>BusinessAlerts API Simple Alert Post</title></head>
<body>
<h1>BusinessAlerts API Simple Alert Post</h1>
<h2>Please authenticate your credentials</h2>
<h3><?php echo $msg?></h3>
<form method="post" action="<?php echo $_SERVER["PHP_SELF"] ?>">
API Username: <input type=text name="api_username" size="30">[Get from "Settings" page in "Account" Section]<br />
API Password: <input type=password name="api_password" size="30">[Get from "Settings" page in "Account" Section]<br />
API Signature: <input type=text name="api_signature" size="50">[Get from "Settings" page in "Account" Section]<br />
<input type=submit name=submit value="Authenticate and Proceed">
</form>
</body>
</html>

